var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { cloneElement, Children } from 'react';
import classNames from 'classnames';
import Checkbox from '../checkbox';
var prefixCls = 'nami-agreement';
export var Agreement = function (props) {
    var onChange = props.onChange, className = props.className, checked = props.checked, agreeText = props.agreeText, children = props.children, chexkboxProps = props.chexkboxProps, otherProps = __rest(props, ["onChange", "className", "checked", "agreeText", "children", "chexkboxProps"]);
    var agreementCls = classNames(prefixCls, className);
    var renderItem = function () {
        return Children.map(children, function (child) {
            var childElement = child;
            return cloneElement(childElement, otherProps);
        });
    };
    return (React.createElement("div", __assign({ className: agreementCls }, otherProps),
        React.createElement(Checkbox, __assign({ checked: checked, onChange: onChange }, chexkboxProps), agreeText),
        React.createElement("span", { className: prefixCls + "-item" }, renderItem())));
};
Agreement.defaultProps = {
    agreeText: '同意'
};
export default Agreement;
