import { ButtonHTMLAttributes, FC } from 'react';
export declare type ButtonSize = 'middle' | 'small';
export declare type ButtonType = 'ghost' | 'light' | 'primary';
interface BaseButtonProps {
    /** 控制宽度100% */
    block?: boolean;
    /** 禁用 */
    disabled?: boolean;
    /** 加载中 */
    loading?: boolean;
    /** 加载中的文本 */
    loadingText?: string;
    /**button类型 */
    btnType?: ButtonType;
    /** button大小 */
    size?: ButtonSize;
}
declare type NativeButtonProps = BaseButtonProps & ButtonHTMLAttributes<HTMLElement>;
export declare type ButtonProps = Partial<NativeButtonProps>;
export declare const Button: FC<ButtonProps>;
export default Button;
/**
 * 原意的type是此时的btnType
 * 原意的htmlType是此时的默认属性type
 */
