var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { useState, useRef, useEffect, useImperativeHandle, forwardRef } from 'react';
import Toast from '../toast';
import Modal from '../modal';
import classNames from 'classnames';
var prefixCls = 'nami-captcha-modal';
export var CaptchaModal = forwardRef(function (props, ref) {
    var timer = useRef();
    var _a = useState(''), captcha = _a[0], setcaptcha = _a[1];
    var _b = useState(''), seconds = _b[0], setseconds = _b[1];
    var visible = props.visible, title = props.title, phoneNumber = props.phoneNumber, confirmLoading = props.confirmLoading, confirmLoaning = props.confirmLoaning, captchaTipsShow = props.captchaTipsShow, className = props.className, okButtonProps = props.okButtonProps, otherProps = __rest(props, ["visible", "title", "phoneNumber", "confirmLoading", "confirmLoaning", "captchaTipsShow", "className", "okButtonProps"]);
    var captchaModalCls = classNames(prefixCls, className);
    useEffect(function () { return function () {
        timer.current && clearInterval(timer.current);
    }; }, []);
    useImperativeHandle(ref, function () { return ({
        clearCaptchaValue: function () {
            setcaptcha('');
        },
        clearInterval: function () {
            timer.current && clearInterval(timer.current);
        },
        // 倒计时
        countDown: function (seconds) {
            timer.current && clearInterval(timer.current);
            setseconds(seconds);
            timer.current = setInterval(function () {
                var _seconds = --seconds;
                setseconds(_seconds);
                if (_seconds <= 0) {
                    timer.current && clearInterval(timer.current);
                }
            }, 1000);
        }
    }); });
    var handleChange = function (e) {
        var onChange = props.onChange;
        var value = (e.target.value = e.target.value.replace(/\D/g, ''));
        if (!/^[0-9]*$/.test(value)) {
            Toast('请输入正确的验证码');
            return;
        }
        setcaptcha(value);
        onChange && onChange(value);
    };
    var handleResend = function () {
        var onResend = props.onResend;
        onResend && onResend();
    };
    var handleOk = function () {
        var onOk = props.onOk;
        onOk && onOk();
    };
    var handleCancel = function () {
        timer.current && clearInterval(timer.current);
        setcaptcha(function () { return ''; });
        var onCancel = props.onCancel;
        onCancel && onCancel();
    };
    var handleCaptchaTipsClick = function () {
        var onCaptchaTipsClick = props.onCaptchaTipsClick;
        onCaptchaTipsClick && onCaptchaTipsClick();
    };
    var renderSendButton = function () { return (React.createElement("button", { type: 'button', disabled: seconds > 0, onClick: handleResend, "data-testid": 'resendBtn' }, seconds > 0 ? seconds + "\u79D2\u540E\u91CD\u65B0\u53D1\u9001" : '重获验证码')); };
    return (React.createElement(Modal, __assign({ className: captchaModalCls, title: title, confirmLoading: confirmLoading || confirmLoaning, onCancel: handleCancel, okButtonProps: __assign({ loadingText: '', disabled: captcha.length < 4 }, okButtonProps), onOk: handleOk, visible: visible }, otherProps),
        React.createElement("div", { className: captchaModalCls + "-content", "data-testid": 'captcha-main' },
            React.createElement("p", null, "\u5DF2\u53D1\u9001\u9A8C\u8BC1\u7801\u77ED\u4FE1\u5230"),
            React.createElement("p", { className: captchaModalCls + "-phone" }, phoneNumber),
            React.createElement("div", { className: captchaModalCls + "-input" },
                React.createElement("input", { "data-testid": 'input', type: 'tel', maxLength: 6, value: captcha, onChange: handleChange, placeholder: '\u8BF7\u8F93\u5165\u9A8C\u8BC1\u7801' }),
                renderSendButton()),
            captchaTipsShow ? (React.createElement("div", { className: captchaModalCls + "-tips", onClick: handleCaptchaTipsClick }, "\u6536\u4E0D\u5230\u9A8C\u8BC1\u7801\uFF1F")) : null)));
});
CaptchaModal.defaultProps = {
    title: '验证手机号',
    okButtonProps: {}
};
export default CaptchaModal;
