var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import classNames from 'classnames';
import Icon from '../icon';
var prefixCls = 'nami-checkbox';
export var Checkbox = function (props) {
    var _a;
    var className = props.className, children = props.children, disabled = props.disabled, checked = props.checked, onChange = props.onChange, otherProps = __rest(props, ["className", "children", "disabled", "checked", "onChange"]);
    var checkboxCls = classNames(prefixCls, (_a = {},
        _a[prefixCls + "-disabled"] = disabled,
        _a), className);
    var handleChange = function (e) {
        onChange && onChange(e.target.checked);
    };
    return (React.createElement("label", __assign({ className: checkboxCls }, otherProps),
        React.createElement("input", { type: 'checkbox', disabled: disabled, className: prefixCls + "-input", checked: checked, onChange: handleChange }),
        checked ? (React.createElement(Icon, { className: prefixCls + "-icon " + prefixCls + "-icon-checked", type: '\uE6AB' })) : (React.createElement(Icon, { className: prefixCls + "-icon", type: '\uE6A4' })),
        children ? React.createElement("span", { className: prefixCls + "-text" }, children) : null));
};
Checkbox.defaultProps = {
    checked: false,
    disabled: false
};
export default Checkbox;
