import React, { Fragment, useEffect } from 'react';
import ReactDOM from 'react-dom';
import BodyScroll from '@bairong/body-scroll';
import { CSSTransition } from 'react-transition-group';
import classNames from 'classnames';
var prefixCls = 'nami-modal-wrapper';
var node = document.createElement('div');
export var ModalWrapper = function (props) {
    var visible = props.visible, className = props.className, children = props.children, onClose = props.onClose, maskClosable = props.maskClosable;
    useEffect(function () {
        document.body.appendChild(node);
        return function () {
            BodyScroll['abled']();
            document.body.removeChild(node);
        };
    }, []);
    useEffect(function () {
        BodyScroll[visible ? 'disabled' : 'abled']();
    }, [visible]);
    var handleMaskClick = function () {
        maskClosable && onClose && onClose();
    };
    var renderContent = function () { return React.createElement("div", { className: prefixCls + "-content" }); };
    var renderMask = function () { return (React.createElement("div", { className: prefixCls + "-mask", onClick: handleMaskClick, "data-testid": 'mask' })); };
    var renderModalWrapper = function () {
        var modalWrapperCls = classNames(prefixCls, className);
        return (React.createElement(Fragment, null,
            React.createElement(CSSTransition, { in: visible, timeout: 300, unmountOnExit: true, classNames: prefixCls },
                React.createElement("div", { className: modalWrapperCls }, children || renderContent())),
            React.createElement(CSSTransition, { in: visible, timeout: 300, unmountOnExit: true, classNames: prefixCls + "-mask" }, renderMask())));
    };
    return ReactDOM.createPortal(renderModalWrapper(), node);
};
ModalWrapper.defaultProps = {
    visible: false,
    maskClosable: false
};
export default ModalWrapper;
