import { FC, ReactNode } from 'react';
import { ButtonProps } from '../button';
export interface modalProps {
    /** modal是否展示 */
    visible?: boolean;
    /** 按钮是否展示 */
    footerHide?: boolean;
    /** 遮罩层是否可点击 */
    maskClosable?: boolean;
    /** 是否展示确定按钮 */
    showOkButton?: boolean;
    /** 是否展示取消按钮 */
    showCancelButton?: boolean;
    /** 是否展示关闭按钮 */
    showCloseButton?: boolean;
    /** 是否展示确定按钮的loading状态 */
    confirmLoading?: boolean;
    /** 取消按钮文案 */
    cancelText?: string;
    /** 确定按钮文案 */
    okText?: string;
    /** className */
    className?: string;
    /** modalWrapper 的className */
    wrapperClassName?: string;
    /** 取消按钮的剩余参数 */
    cancelButtonProps?: ButtonProps;
    /** 确定按钮的剩余参数 */
    okButtonProps?: ButtonProps;
    /** 点击遮罩层的触发函数  */
    onClose?: () => any;
    /** 点击取消按钮的触发函数 */
    onCancel?: () => any;
    /** 点击确定按钮的触发函数 */
    onOk?: () => any;
    /** 标题 */
    title?: ReactNode;
    /** children */
    children: any;
}
export declare const Modal: FC<modalProps>;
export default Modal;
