var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from 'react';
import Button from '../button';
import classNames from 'classnames';
import Icon from '../icon';
import ModalWrapper from '../modal-wrapper/index';
var prefixCls = 'nami-modal';
export var Modal = function (props) {
    var visible = props.visible, wrapperClassName = props.wrapperClassName, maskClosable = props.maskClosable, onClose = props.onClose, onCancel = props.onCancel, onOk = props.onOk, title = props.title, cancelButtonProps = props.cancelButtonProps, okButtonProps = props.okButtonProps, footerHide = props.footerHide, className = props.className, children = props.children, cancelText = props.cancelText, okText = props.okText, confirmLoading = props.confirmLoading, showOkButton = props.showOkButton, showCancelButton = props.showCancelButton, showCloseButton = props.showCloseButton;
    var handleOk = function () {
        onOk && onOk();
    };
    var handleCancel = function () {
        onCancel && onCancel();
    };
    var handleClose = function () {
        showCloseButton && onClose && onClose();
    };
    var renderTitle = function () {
        return title && (React.createElement("div", { className: prefixCls + "-header" },
            React.createElement("h3", { className: prefixCls + "-title" }, title)));
    };
    var renderFoooter = function () {
        var _a;
        var footerCls = classNames(prefixCls + "-footer", (_a = {},
            _a[prefixCls + "-footer-center"] = !showOkButton || !showCancelButton,
            _a));
        return (!footerHide && (React.createElement("div", { className: footerCls },
            showCancelButton && (React.createElement(Button, __assign({ btnType: 'ghost', size: 'middle' }, cancelButtonProps, { onClick: handleCancel }), cancelText)),
            showOkButton && (React.createElement(Button, __assign({ btnType: 'primary', size: 'middle' }, okButtonProps, { loading: confirmLoading, onClick: handleOk }), okText)))));
    };
    var renderCloseButton = function () {
        var showCloseButton = props.showCloseButton;
        return (showCloseButton && (React.createElement(Icon, { className: prefixCls + "-close-btn", type: '\uE68B', onClick: handleClose })));
    };
    var renderModal = function () {
        var _a;
        var modalCls = classNames(prefixCls, (_a = {},
            _a[prefixCls + "-without-footer"] = footerHide,
            _a), className);
        return (React.createElement("div", { className: modalCls, "data-testid": 'modal-main' },
            renderTitle(),
            React.createElement("div", { className: prefixCls + "-body" },
                " ",
                children),
            renderFoooter(),
            renderCloseButton()));
    };
    return (React.createElement(ModalWrapper, { visible: visible, className: wrapperClassName, maskClosable: maskClosable, onClose: onClose }, renderModal()));
};
Modal.defaultProps = {
    visible: false,
    footerHide: false,
    maskClosable: false,
    showOkButton: true,
    showCancelButton: true,
    showCloseButton: false,
    confirmLoading: false,
    cancelText: '取消',
    okText: '确定',
    className: '',
    cancelButtonProps: {},
    okButtonProps: {}
};
export default Modal;
