import React from 'react';
import ReactDOM from 'react-dom';
import Message from './Message';
var Toast = function (message, duration, callback) {
    if (duration === void 0) { duration = 2000; }
    if (window.BrBridge && window.BrBridge.env.isApp) {
        showNativeToast(message, duration, callback);
    }
    else {
        showToast(message, duration, callback);
    }
};
var showNativeToast = function (message, duration, callback) {
    if (duration === void 0) { duration = 2000; }
    window.BrBridge.call('Common', 'toast', {
        content: message,
        time: duration
    });
    setTimeout(function () {
        callback && callback();
    }, duration - 10);
};
var showToast = function (message, duration, callback) {
    var div = document.createElement('div');
    document.body.appendChild(div);
    ReactDOM.render(React.createElement(Message, { message: message }), div);
    setTimeout(function () {
        ReactDOM.unmountComponentAtNode(div);
        document.body.removeChild(div);
        callback && callback();
    }, duration);
};
export default Toast;
